unit Unit1;

{
   a microseconds clock for Delphi versions
   that support 64 bit integers (type = Int64)
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    StaticText1: TStaticText;
    Button2: TButton;
    StaticText2: TStaticText;
    Label1: TLabel;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CPUclock : double;    //CPU clock speed in MHz

implementation

{$R *.dfm}

procedure getCPUticks(var count: Int64);
//store 64 bits CPU clock in variable count
begin
 asm
  mov ECX,count;
  RDTSC;          //lower 32 bits --> EAX, upper 32 bits ---> EDX
                  //RDTSC = DB $0F,$31
  mov [ECX],EAX;
  add ECX,4;
  mov [ECX],EDX;
 end;
end;

procedure setCPUclock;
//set variable CPUclock
//call this procedure before measuring any process time
var t1,t2 : cardinal;         //system clock ticks
    cput1,cput2 : Int64;      //CPU clock ticks
begin
 t1 := getTickCount;          //get milliseconds clock
 while getTickCount = t1 do;  //sync with start of 1 millisec interval
 getCPUticks(cput1);          //get CPU clock count
 t1 := gettickcount;
 repeat
  getCPUticks(cput2);         //get CPU clock count
  t2 := gettickcount;
 until t2-t1 >= 500;
 CPUclock := (cput2-cput1)/((t2-t1)*1e3);      //set CPU clock in microsecs
 form1.statictext2.caption := formatfloat('####',CPUclock)+' MHz';
end;

procedure TForm1.Button1Click(Sender: TObject);
//button1 enables display of CPU ticks in statictext1
var count: Int64;
begin
 getCPUticks(count);
 statictext1.Caption := inttostr(count);
end;

procedure TForm1.Button2Click(Sender: TObject);
//a process of which time is measured
var t1,t2 : Int64;
    i : integer;
    x,y : double;
begin
 getCPUticks(t1);
 x := 1000;             //process starts here
 y := 1;
 for i := 1 to 1000 do
  begin
   x := (x + y)/2;
   y := 1000/x;
  end;                 //process ends here
 getCPUticks(t2);
 statictext1.Caption := formatfloat('####.####',(t2-t1)/CPUclock) + ' microsecs';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 application.ProcessMessages;
 setCPUclock;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 application.ProcessMessages;  
 setCPUclock;
end;

end.
 